var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes = function() {
    "use strict";

    var _domLblTotalPacotes = $$("#lblTotalPacotes"),
        _domEmptyListaPacotes = $$("#emptyListaPacotes"),
        _domFooter = $$("#telaPrincipal footer");

    return {
        
        config: null,
        lista: null,
        listaNotificacoes: [],
        
        
        AbrirDetalhesPacote: function(idPacote) {
            
            var data = RastreadorPacotes.StrAcessoWebService();

            // não esta logado ou não tem lista
            if ((data == null) || (lista == null)) {
                return;
            }
            
            var objPacote = Lungo.Core.findByProperty(lista, "Id", idPacote);
            RastreadorPacotes.Detalhes.IniciarPacote(objPacote);
        },
        
        
        AtualizarPacote: function(idPacote, objPacoteNovo, objPosicoes) {
            
            // seta as posições
            objPacoteNovo.Posicao = objPosicoes;
            
            // verifica se a lista já existe
            if ((RastreadorPacotes.lista == null) || (RastreadorPacotes.lista.length == 0)) {
                RastreadorPacotes.lista = [];
                RastreadorPacotes.lista.push(objPacoteNovo);

                RastreadorPacotes.Principal.CriarLista(RastreadorPacotes.lista, true);

                return;
            }
            
            
            // se caiu aqui significa que já existe algum pacote na lista atual
            // neste caso, tenta localizar o pacote
            // obtém o índice na listaAtual
            var indice = listaAtual.searchInObject("Id", idPacote);
            
            if (indice >= 0) {
                if (listaAtual[indice].Id == idPacote) {
                    RastreadorPacotes.lista[indice] = objPosicoes;
                }
            } else {
                RastreadorPacotes.lista.push(objPacoteNovo);
            }
            
            RastreadorPacotes.Principal.CriarLista(RastreadorPacotes.lista, true);
        },
        
        
        AvaliarNaPlayStore: function() {
            var LINK = "https://play.google.com/store/apps/details?id=tmz.rastreador";

            MyMobile.Confirm(
                "Avaliação", 
                "Esta gostando deste aplicativo? Por favor, tire um tempinho para avaliá-lo. Sua avaliação é muito importante!",
                "Avaliar agora,Lembrar mais tarde,Agora não",
                function(index) {
                    
                    alert(index);
                    
                    switch (index) {
                        case 1: { // avaliar agora
                            break;
                        }
                        case 2: { // lembrar mais tarde
                            break; 
                        }
                        case 3: { // agora não
                            break;
                        }
                    }
                }
            );
        },


        DeletarHtmlItem: function(idPacote) {
            var indice = -1,
                splitPacote = idPacote.split(",");

            // remove todo o HTML e os objetos do array 
            for (var j = 0, len = splitPacote.length; j < len; j++) {
                var o = document.querySelectorAll("#telaPrincipal #listaPacotes li[data-id='" + splitPacote[j] + "']");
                
                if ((o != null) && (o.length > 0)) {
                    // poderia ser: o[0].remove()
                    // porém do jeito acima deu erro (sei la porque) no phonegap
                    // o erro foi: #<HTMLLIElement> has no method 'remove'
                    o[0].parentElement.removeChild(o[0]);
                }
                
                indice = RastreadorPacotes.lista.searchInObject("Id", splitPacote[j].trim());
                if (indice >= 0) {
                    RastreadorPacotes.lista.splice(indice, 1); // start, deleteCount
                }
            }
            

            _domLblTotalPacotes.html("( " + RastreadorPacotes.lista.length + " )");
            localStorage.setItem("list", JSON.stringify(RastreadorPacotes.lista));
            
            
            if (RastreadorPacotes.lista.length == 0) {
                
                if (typeof _cancelarEdicaoLista != "undefined") {
                    _cancelarEdicaoLista();
                }
                
                _domEmptyListaPacotes.show();
                _domFooter.hide();
            }
        },
        
        EntrarEmContato: function() {
            
            try {
                var email = "contato@rastreadordepacotes.com.br",
                    assunto = "suporte",
                    mensagem = "",
                    env = Lungo.Core.environment();
                
                mensagem = "Olá Thiago,\neu gostaria de...\n\n\n\nVersão do app: " + app.config.versao + "\n" +
                            "" + env.os.name + " " + env.os.version + " - " + app.device.model + " (" + env.screen.width + "/" + env.screen.height + ")";
                mensagem = encodeURIComponent(mensagem);
    
                window.location.href = "mailto:" + email + "?subject=" + assunto + "&body=" + mensagem;
                
                /*window.plugin.email.open({
                    to: ['contato@rastreadordepacotes.com.br'],
                    //cc: ['erika.mustermann@appplant.de'],
                    //bcc: ['john.doe@appplant.com', 'jane.doe@appplant.com'],
                    subject: 'suporte',
                    isHtml: true,
                    body: "Olá Thiago,<br>eu gostaria de...<br><br><br><br>Versão mobile: <b>" + app.config.versao + "</b>"
                });*/
            } catch(err) {
            }
        },
        
        
        /*EnviarEmailAjuda: function() {
            
            navigator.screenshot.save(function(error, res) {
            
                if (error) {
                    //alert(ObjectToString(error));
                    return;
                }
            
                window.plugin.email.open({
                    to: ['contato@rastreadordepacotes.com.br'],
                    subject: 'suporte',
                    isHtml: true,
                    body: "Versão mobile: <b>" + app.config.versao + "</b>",
                    attachments: [
                        'file:/' + res.filePath
                    ]
                });
            });//, "jpg", 50);
        },*/


        GetPacotePeloCampo: function(campo, valor) {
            if (this.lista == null) {
                return null;
            }

            return Lungo.Core.findByProperty(this.lista, campo, valor);
        },

        
        ResetarLocalStorage: function() {
            localStorage.removeItem("lastUpdate");
            localStorage.removeItem("list");
            localStorage.removeItem("pacotesMovimentados");
            localStorage.removeItem("search");
            localStorage.removeItem("sort");
            //localStorage.removeItem("lastGetConfiguracao"); // não remover
            //localStorage.removeItem("options"); // não remover
            localStorage.removeItem("user");
            localStorage.removeItem("version");
            localStorage.removeItem("usuarioNovo");
        },
        
        
        SalvarPacote: function(action, inclusao, data, obj) {
            
            MyMobile.ActivityStart("", "Salvando...");


            $$.post(
                app.config.server.format(action),
                data,
                function(retorno) {
                    
                    try {

                        MyMobile.ActivityStop();
                        
                        // se houve algum erro, sai fora e volta para o objeto antigo
                        if ((retorno == null) || (retorno.success == null) || (!retorno.success)) {
                            // se deu algum erro, volta o objeto antigo
                            //RastreadorPacotes.Pacote.AlterarHtml(objAntigo, linha);
                            
                            /*Lungo.Notification.success('Erro', "Erro não identificado.", 'cancel', 5, function() {
                                Lungo.Notification.hide();
                            });*/
                            MyMobile.Alert("Opa...", "Erro não identificado", "Ok");
                            return;
                        }
                        
                        var list = RastreadorPacotes.lista;
                        
                        if (list == null) {
                            list = [];
                        }

                        
                        // se for inclusão...
                        if (inclusao) {
                            
                            // esse é o pacote retornado pela requisição
                            // adiciona este pacote à lista
                            retorno.pacote[0].Posicao = JSON.parse(retorno.rows.Lista[0].Posicao);
                            list.push(retorno.pacote[0]);
                            
                            localStorage.setItem("list", JSON.stringify(list));
                            
                            var search = JSON.parse(localStorage.getItem("search"));
                            
                            //list = RastreadorPacotes.Principal.PrepararLista(list);
                            //RastreadorPacotes.Principal.FiltrarLista(search, list);
                            //RastreadorPacotes.lista = list;
                            RastreadorPacotes.Principal.CriarLista(list, false);
    

                            MyMobile.Alert(
                                "", 
                                retorno.mensagem, 
                                "Ok",
                                function() { 
                                    Lungo.Router.back();
                                }
                            );
    
                            return;
                        }
                        
    
                        // ********************************************************
                        // SE CAIU AQUI É PORQUE O PACOTE JÁ EXISTE ***************
                        // ********************************************************
                        
                        
                        // localiza o pacote pelo seu ANTIGO código de rastreio
                        if (list == null) {
                            return;
                        }
                            
                        var indice = -1;
    
                        for (var i = 0; i < list.length; i++) {
                            if (list[i].Id == obj.Id) {
                                indice = i;
                                break;
                            }
                        }
                        
                        /// se encontrar o pacote...
                        if (indice >= 0) {
                            // verifica se o retorno da requisição possui alguma Posição
                            if ((retorno.rows != null) && (retorno.rows.length > 0)) {
                                list[indice] = retorno.rows[0];
                            } else {
                                list[indice] = obj;
                            }
                            
                            localStorage.setItem("list", JSON.stringify(list));
                        }
    
                        var search = JSON.parse(localStorage.getItem("search"));

                        //list = RastreadorPacotes.Principal.PrepararLista(list);
                        //RastreadorPacotes.Principal.FiltrarLista(search, list);
                        RastreadorPacotes.Principal.CriarLista(list, false);
                        
                        // atualiza a interface que exibe os dados do pacote
                        RastreadorPacotes.Detalhes.AlterarTitulo(obj);
                        
                        /*Lungo.Notification.success('Sucesso', retorno.mensagem, 'ok', 2, function() {
                            Lungo.Notification.hide();
                            Lungo.Router.back();
                        }); */
                        
                        MyMobile.Alert(
                            "", 
                            retorno.mensagem,
                            "Ok",
                            function() { 
                                Lungo.Router.back();
                            }
                        );
                    } catch(err) {
                        MyMobile.Alert("Erro...", err, "Ok");
                    }
                }
            );
        },


        StrAcessoWebService: function() {
            var objUser = JSON.parse(localStorage.getItem("user"));
            if (objUser == null) {
                return "";                    
            }

            var data = {
                l: objUser.login,
                pk: tmz.Base64.encode(objUser.publicKey),
                sistema: app.config.sistema,
                versao: app.config.versao
            };
            
            return data;
        },


        ValidarCodigoRastreio: function(codigo) {
            codigo = codigo.replaceAll(" ", "");
            return codigo.match(/[A-Z]{2}\d{9}[A-Z]{2}/i);
        }

    };
}();