var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.DadosPacote = function() {
    "use strict";
    
    
    var _idPacote = 0,
        _codigoRastreio = "",
        _dom = {
            codigoRastreio: document.getElementById("txtCodigoPacote"),
            descricao: document.getElementById("txtDescricaoPacote"),
            observacao: document.getElementById("txtObservacaoPacote"),
            avisarTambem: document.getElementById("txtAvisarTambem"),
            categoria: document.getElementById("txtCategoriaPacote")
        };

    
    var _definirAcaoBotoes = function() {
        $$("#telaCadastrarPacote [data-action=salvar]").tap(function() {
            RastreadorPacotes.DadosPacote.Salvar();
        });
    };

    
    return {
        Init: function() {
            _definirAcaoBotoes();
        },
        
        
        Abrir: function(objPacote) {
            if (objPacote == null) {
                return;
            }

            _idPacote = objPacote.Id;
            _codigoRastreio = objPacote.CodigoRastreio;
            _dom.codigoRastreio.value = objPacote.CodigoRastreio;
            _dom.descricao.value = objPacote.Descricao;
            _dom.observacao.value = objPacote.Observacao;
            _dom.avisarTambem.value = objPacote.AvisarTambem;
            _dom.categoria.value = objPacote.Categoria;

            $$("#telaCadastrarPacote h1").html("Alterar dados");
        },
        
        
        Novo: function(codigoRastreio) {

            _dom.codigoRastreio.value = "";
            _dom.codigoRastreio.removeAttribute("disabled");
            _dom.descricao.value = "";
            _dom.observacao.value = "";
            _dom.avisarTambem.value = "";
            _dom.categoria.value = "";
            

            if ((typeof codigoRastreio != "undefined") && (codigoRastreio != "")) {
                _dom.codigoRastreio.value = codigoRastreio;
            }
            
            $$("#telaCadastrarPacote h1").html("Cadastrar Pacote");
        },
        
        
        Validar: function() {
            if (_dom.codigoRastreio.value.trim() == "") {
                MyMobile.Alert("", "Por favor, informe o código de rastreio.", "Ok");
                return false;
            }
            
            if (!RastreadorPacotes.ValidarCodigoRastreio(_dom.codigoRastreio.value)) {
                MyMobile.Alert("", "O código de rastreio informado não é válido.", "Ok");
                return false;
            }
            
            if (_dom.descricao.value.trim() == "") {
                MyMobile.Alert("", "Por favor, informe a descrição.", "Ok");
                return false;
            }
            
            return true;
        },
        
        
        Salvar: function() {
            
            if (!this.Validar()) {
                return;
            }
            

            if ((!app.isOnline) && (app.isMobile)) {
                MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
                return;
            }
                        
            
            var obj = RastreadorPacotes.GetPacotePeloCampo("CodigoRastreio",  _dom.codigoRastreio.value.trim()),
                inclusao = (obj == null),
                action = (inclusao) ? "PacoteIncluirPacote" : "PacoteAlterarDados",
                data = RastreadorPacotes.StrAcessoWebService();
                
            data.idPacote = (inclusao) ? 0 : obj.Id;
            data.idTransportadora = (inclusao) ? 1 : obj.IdTransportadora;
            data.favorito = (inclusao) ? false : obj.Favorito;
            data.formaInclusao = (inclusao) ? "Manual" : obj.FormaInclusao;
            data.servicoUtilizado = (inclusao) ? "Android" : obj.ServicoUtilizado;
            data.tipoCaixa = (inclusao) ? "Entrada" : obj.TipoCaixa;
            data.codigoRastreio = _dom.codigoRastreio.value.trim();
            data.descricao = _dom.descricao.value.trim();
            data.avisarTambem = _dom.avisarTambem.value.trim();
            data.observacao = _dom.observacao.value.trim();
            data.categoria = _dom.categoria.value.trim();
            
            if (!inclusao) {
                
                // se já foi entregue OU já possuir alguma posição, coloca o código de rastreio inicial
                if ( (obj.Status.toLowerCase() == "entregue") || ((obj.Posicao != null) && (obj.Posicao.length > 0)) ) {
                    //_dom.codigoRastreio.disabled = true;
                    obj.CodigoRastreio = _codigoRastreio;
                } else {
                    obj.CodigoRastreio = _dom.codigoRastreio.value.trim();
                }
                
                obj.CodigoRastreio = _dom.codigoRastreio.value.trim();
                obj.Descricao = _dom.descricao.value.trim();
                obj.Observacao = _dom.observacao.value.trim();
                obj.AvisarTambem = _dom.avisarTambem.value.trim();
                obj.Categoria = _dom.categoria.value.trim();
            }
            

            RastreadorPacotes.SalvarPacote(action, inclusao, data, obj);
        }
    };
    
}();