var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.Detalhes = function() {
    "use strict";
    
    var _objPacote = null,
        _domBody = $$("article#listaDetalhesPacote"),
        _domUL = _domBody.find("ul"),
        _domEmptyListaDetalhesPacotes = $$("#emptyListaDetalhesPacotes"),
        _lista = null,
        _pullListaDetalhes;
    
    
    var _apagarLista = function() {
        _domUL.html("");
    };
    
    
    var _alterarDados = function() {
        RastreadorPacotes.DadosPacote.Abrir(_objPacote);
        
        Lungo.Router.section("telaCadastrarPacote");
    };
    
    
    //
    var _atualizarLista = function() {

        if (_objPacote.Status.toLowerCase() == "entregue") {
            MyMobile.Alert("", "Este pacote já foi entregue", "Ok");
            _ocultarPull();
            return;
        }
        
        if (!app.isOnline) {
            MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
            _ocultarPull();

            return;
        }

        var data = RastreadorPacotes.StrAcessoWebService();
        data.id = _objPacote.Id;
        
        
        MyMobile.ActivityStart("", "Atualizando...");

        $$.post(
            app.config.server.format("PacoteGetNovasPosicoes"),
            data,
            function(retorno) {
                
                MyMobile.ActivityStop();
                _ocultarPull();
                
                if (retorno == null) {
                    MyMobile.Alert("", "Erro não identificado", "Ok");
                    return;
                }
                
                if (retorno.totalRegistros == 0) {
                    MyMobile.Alert("", "Este pacote não foi movimentado desde a última atualização.", "Ok");
                    
                    if ((_objPacote.Posicao != null) && (_objPacote.Posicao.length > 0)) {
                        _domEmptyListaDetalhesPacotes.hide();
                    } else {
                        _domEmptyListaDetalhesPacotes.show();
                    }

                    return;
                }
                
                
                _criarLista();
            }
        );
    };
    
    
    //
    var _criarLista = function() {
        if (_domUL == null) {
            return;
        }
        
        if ((_objPacote == null) || (_objPacote.Posicao == null) || (_objPacote.Posicao.length == 0)) {
            _definirAcaoLista();
            _domEmptyListaDetalhesPacotes.show();

            return;
        }
        
        _domEmptyListaDetalhesPacotes.hide();
        
        // pega o objeto de posição de quando o pacote foi postado
        /*var postadoEm = _getPostado(_objPacote.Posicao),
            dias = _getQuantidadeDiasPostado(_objPacote, postadoEm);*/
        

        for (var i = _objPacote.Posicao.length - 1; i >= 0; i--) {
            var li = document.createElement("li"),
                spanData = document.createElement("span"),
                spanDetalhes = document.createElement("span"),
                entregaEfetuada = false,
                divComImg = null;


            if (_objPacote.Posicao[i].Acao.toLowerCase() == "entrega efetuada") {
                entregaEfetuada = true;
                divComImg = document.createElement("div");
            }
            

            // DATA
            spanData.className = "spanData";
            spanData.innerHTML = tmz.Convert.toDateTime(_objPacote.Posicao[i].Data, "y-M-d h:m:s", "d/M/y h:m");
            
            spanDetalhes.innerHTML = _objPacote.Posicao[i].Detalhes;
            spanDetalhes.className = "fontSize11";
            
            if (entregaEfetuada) {
                divComImg.appendChild(spanData);
                divComImg.appendChild(document.createElement("BR"));
                
                divComImg.appendChild(spanDetalhes);
                divComImg.appendChild(document.createElement("BR"));
            } else {
                li.appendChild(spanData);
                li.appendChild(document.createElement("BR"));
                
                if (_objPacote.Posicao[i].Detalhes.toLowerCase() == "erro de lançamento") {
                    spanDetalhes.innerHTML = spanDetalhes.innerHTML + "<br>" + _objPacote.Posicao[i].Acao;
                }
                    
                li.appendChild(spanDetalhes);
                li.appendChild(document.createElement("BR"));
            }

            
            li.className = "liComSombra liPequeno";
            
            if (entregaEfetuada) {
                li.className += " thumb";
                
                var img = document.createElement("img");
                img.src = "img/success_48x48.png";
                img.style.cssText = "margin: 4px;";

                li.appendChild(img);
                li.appendChild(divComImg);
            }

            _domUL[0].appendChild(li);
        }
        
        
        _definirAcaoLista();
    };
    

    //
    var _definirAcaoBotoes = function() {
        
        $$("#btnAlterarDadosPacote").tap(function() {
            RastreadorPacotes.Detalhes.AlterarDados();
        });
        
        
        $$("#menuAlterarDadosPacote").tap(function() {
            RastreadorPacotes.Detalhes.AlterarDados();
        });
        
        
        $$("#menuExcluirPacote").tap(function() {
            RastreadorPacotes.Detalhes.ExcluirPacote();
        });
        
        
        $$("#menuRastrearPacote").tap(function() {
            RastreadorPacotes.Detalhes.AtualizarLista();
        });
        
        
        $$("#menuVoltarParaLista").tap(function() {
            Lungo.Router.back();
        });


        $$("#menuOpcoesDetalhesPacote [data=menuEntrarEmContato]").tap(function() {
            RastreadorPacotes.EntrarEmContato();
        });
        

        $$("#menuOpcoesDetalhesPacote [data=menuSobre]").tap(function() {
            Lungo.Router.section("telaSobreApp");
        });
    };
    


    var _definirAcaoLista = function() {

        // quando clicar na lista...
        $$("#listaDetalhesPacote").tap(function() {

            var menuAberto = $$("#menuOpcoesDetalhesPacote").hasClass("show");
            RastreadorPacotes.Detalhes.MenuAberto = menuAberto;

            if (menuAberto) {
                // oculta o menu de opções
                RastreadorPacotes.Detalhes.AbrirDetalhes = false;
                Lungo.Aside.toggle();
            }
            
            return;

        });
    };


    var _definirTitulo = function() {
        var titulo = document.querySelectorAll("#telaDetalhesPacote header h1");
        
        if ((titulo == null) || (titulo.length == 0)) {
            return;
        }

        var str = (_objPacote.Descricao.replace("\n", " - ") + " - " + _objPacote.CodigoRastreio).substr(0,40);
        titulo[0].innerHTML = str;
    };


    var _excluirPacote = function() {
        if (!app.isOnline) {
            MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
            _ocultarPull();

            return;
        }


        MyMobile.Confirm(
            "Confirmação", 
            "Tem certeza que deseja excluir este pacote?",
            "Sim,Cancelar",
            function(index) {
                
                if (index == 2) { // 2 == CANCELAR
                    return;
                }
                
                var data = RastreadorPacotes.StrAcessoWebService();
                data.idPacote = _objPacote.Id;
                
                
                MyMobile.ActivityStart("", "Excluindo o pacote...");
        
                $$.post(
                    app.config.server.format("PacoteExcluirPeloId"),
                    data,
                    function(retorno) {
                        
                        MyMobile.ActivityStop();
                        
                        if (!retorno.success) {
                            MyMobile.Alert("", retorno.mensagem, "Ok");
                            return;
                        }
                        
                        RastreadorPacotes.DeletarHtmlItem(_objPacote.Id);

                        MyMobile.Alert(
                            "",
                            "Pacote excluído com sucesso.",
                            "Ok",
                            function() {
                                Lungo.Router.back();
                            }
                        );
                    }
                );
            }
        );
    };


    // obtém a posição de ENTREGUE
    var _getEntregue = function (oLista) {

        if ((window.isNull(oLista)) || (oLista.length === 0)) {
            return null;
        }
        
        var ENTREGA_EFETUADA = "entrega efetuada";

        for (var i = 0; i < oLista.length; i++) {
            if (oLista[i].Acao.toLowerCase() === ENTREGA_EFETUADA) {
                return oLista[i];
            }
        }

        return null;
    };


    // obtém a posição de POSTADO
    var _getPostado = function (oLista) {

        if ((window.isNull(oLista)) || (oLista.length === 0)) {
            return null;
        }

        for (var i = 0; i < oLista.length; i++) {
            if ((oLista[i].Acao.toLowerCase() === "postado") || (oLista[i].Acao.toLowerCase() === "postagem - dh") || (oLista[i].Acao.toLowerCase() === "objeto postado") || (oLista[i].Acao.toLowerCase() === "objeto postado após o horário limite da agência")) {
                return oLista[i];
            }
        }

        return null;
    };
    
    
    
    var _getQuantidadeDiasPostado = function(objPacote, postadoEm) {

        // se não existir o objeto...
        if (window.isNull(postadoEm)) {
            return;
        }


        var dataAtual,
            diasDesdePostagem = 0, 
            strTitle = "";


        // define a data atual como sendo HOJE
        var dataAtual = new Date();

        // verifica se o pacote já foi entregue...
        if (objPacote.Status.toLowerCase() === "entregue") {
            // se já foi entregue, obtém a informação do pacote entregue
            dataAtual = _getEntregue(objPacote.Posicao);
            dataAtual = (window.isNull(dataAtual)) ? new Date() : new Date(dataAtual.Data);
        }

        var dataFinal = new Date(postadoEm.Data);

        diasDesdePostagem = tmz.Date.diasDecorridos(dataFinal, dataAtual);
        diasDesdePostagem = diasDesdePostagem.qtdDias;


        if ((!window.isNull(objPacote.Posicao)) && (objPacote.Posicao.length > 0) && (!window.isNull(postadoEm))) {
            if (diasDesdePostagem >= 1) {
                diasDesdePostagem -= 1;
            }

            switch (diasDesdePostagem) {
                case 0:
                    {
                        strTitle = "Postado hoje";
                        break;
                    }
    
                case 1:
                    {
                        strTitle = "Postado ontem";
                        break;
                    }
    
                default:
                    {
                        strTitle = (diasDesdePostagem === 1) ? "Postado ontem" : "Postado à " + diasDesdePostagem + " dias";
                        break;
                    }
            }
        }



        if (strTitle !== "") {
            var strDias = ((diasDesdePostagem + 1) === 1) ? " dia" : " dias";
            strTitle = (objPacote.Status.toLowerCase() === "entregue") ? "Entregue em " + (diasDesdePostagem + 1) + strDias : strTitle;
        }
    };

    
    var _iniciarPull = function() {
        if (_pullListaDetalhes != null) {
            return;
        }
        
        _pullListaDetalhes = new Lungo.Element.Pull("section#telaDetalhesPacote article", {
            onPull: "Puxe para baixo para atualizar",
            onRelease: "Solte para atualizar",
            onRefresh: "Atualizando...",
            callback: function() {
                
                if (_objPacote.Status.toLowerCase() == "entregue") {
                    MyMobile.Alert("", "Este pacote já foi entregue.", "Ok");
                    _ocultarPull();

                    return;
                }
                
                RastreadorPacotes.Detalhes.AtualizarLista();
            }
        });
    };

    var _iniciarPacote = function(objPacote) {
        if (objPacote == null) {
            MyMobile.Alert("", "Pacote não encontrado.", "Ok");
            return;
        }
        
        _objPacote = objPacote;
        
        Lungo.Router.section("telaDetalhesPacote");
                    
        _apagarLista();
        _definirTitulo();
        _criarLista();
        
        // se o pacote já foi entregue, oculta o menu "RASTREAR"
        if ( (_objPacote.Status != null) && (_objPacote.Status.toLowerCase() != "entregue") ) {
            $$("#menuRastrearPacote").show();
            _iniciarPull();
        } else {
            $$("#menuRastrearPacote").hide();
            //_pullListaDetalhes = null;
            //aqui eu deveria remover a funcionalidade de PULL da lista
            //var tela = $$("#telaDetalhesPacote");
            //tela.removeAttr("data-pull");
            //tela.find("div[data-control=pull]").remove();
        }
    };

    var _ocultarPull = function() {
        if (_pullListaDetalhes == null) {
            return;
        }
        
        _pullListaDetalhes.hide();
    };
    
    
    
    return {
        
        Init: function() {
            _definirAcaoBotoes();
        },
        
        
        AlterarDados: function() {
            _alterarDados();
        },
        
        
        AlterarTitulo: function(objPacote) {
            _objPacote = objPacote;
            _definirTitulo();
        },
        
        
        AtualizarLista: function() {
            _atualizarLista();
        },
        

        ExcluirPacote: function() {
            _excluirPacote();
        },
        
        
        IniciarPacote: function(objPacote) {
            _iniciarPacote(objPacote);
        }
        
    };
}();