var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.Principal = function() {
    "use strict";
    
    var ENTREGA_EFETUADA = "entrega efetuada", 
        _domBody = $$("article#listaPacotes"),
        _domUL = _domBody.find("ul"),
        _domMenuLocalizarPacote = $$("#menuLocalizarPacote"),
        _domEmptyListaPacotes = $$("#emptyListaPacotes"),
        _domSemConexao = $$("#emptySemConexaoListaPacotes"),
        //_domListaSendoAtualizacao = $$("#emptyListaSendoAtualizada"),
        _domLblTotalPacotes = $$("#lblTotalPacotes"),
        _domFooter = $$("#telaPrincipal footer"),
        _domAvisoAtualizacao = $$("#telaPrincipal .avisoAtualizacao"),
        _domMensagemAvisoAtualizacao = _domAvisoAtualizacao.find("span[data=msg]"),
        //_domMensagemPull = null,
        _domEmptyFiltroVazio = $$("#emptyFiltroVazio"),
        _pullListaPacotes = null,
        _strAcessoWebService = "";
    
    
    
    var _apagarLista = function(adicionarEmLocalStorage) {
        _domUL.html("");
        _domLblTotalPacotes.html("( 0 )");
        _domEmptyListaPacotes.show();
        
        _ocultarPull();
        
        if (adicionarEmLocalStorage) {
            RastreadorPacotes.lista = null;
            localStorage.removeItem("list");
        }
    };

    
    var _atualizarLista = function(exibirMensagem) {
        if (!app.isOnline) {
            MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");

            _ocultarPull();

            return;
        }
        
        _cancelarEdicaoLista();
        
        if (exibirMensagem) {
            //_domMensagemAvisoAtualizacao.text("Atualizando a lista");
            //_exibirAvisoAtualizacaoPacote();
            MyMobile.ActivityStart("", "Atualizando...");
        }
        
        console.debug("listaPacotes - vai atualizar lista");
        
        $$.post(
            app.config.server.format("PacoteGetLista"),
            _strAcessoWebService,
            function(retorno) { 
                
                RastreadorPacotes.Principal.listaSendoAtualizada = false;
                
                console.debug("listaPacotes - atualizou a lista");

                try
                {
                    if ((retorno == null) || (!retorno.success)) {
                        MyMobile.Alert("", retorno.mensagem || "Erro não identificado.", "Ok");
                        
                        if (exibirMensagem) {
                            //_ocultarAvisoAtualizacaoPacote();
                            MyMobile.ActivityStop();
                        }
                        
                        _ocultarPull();
                        return;
                    }

                    // indica a data/hora do último update
                    localStorage.setItem("lastUpdate", tmz.Convert.dateToString(new Date()));
                    
                    // importante fazer isso para atualizar a data (lastUpdate)
                    //_alterarMensagemPull();

                    // verifica se existe algum retorno
                    if (retorno.rows == null)
                    {
                        if (exibirMensagem) {
                            //_ocultarAvisoAtualizacaoPacote();
                            MyMobile.ActivityStop();
                        }
                        
                        _apagarLista();
                        _definirEventosLista();
                        _ocultarPull();
                                                    
                        return;
                    }


                    _ocultarPull();
                    _criarLista(retorno.rows, true);
                    
                    
                    // se o retorno for > 0, executa o rastreio de cada pacote
                    if (retorno.rows.length > 0)
                    {
                        RastreadorPacotes.Principal.ProcessarGetNovasPosicoes(0, exibirMensagem);

                        _ocultarPull();
                            
                        if (exibirMensagem) {
                            //_ocultarAvisoAtualizacaoPacote();
                            MyMobile.ActivityStop();
                        }
                        
                        return;
                    }
                    
                    _ocultarPull();
                
                    if (exibirMensagem) {
                        //_ocultarAvisoAtualizacaoPacote();
                        MyMobile.ActivityStop();
                    }

                }
                catch(err)
                {
                    if (exibirMensagem) {
                        //_ocultarAvisoAtualizacaoPacote();
                        MyMobile.ActivityStop();
                    }


                    // se deu algum erro, para não ficar uma LISTA vazia, carrego e exibo a lista antiga mesmo
                    // fazer o que né :(
                    var listaAntiga = localStorage.getItem("list");
                    _criarLista(listaAntiga, false);
                    
                    
                    
                    // fecho a mensagem e dou um alerta pro usuário, pedindo desculpas...
                    MyMobile.Alert(
                        "Erro...",
                        "Desculpe, um erro ocorreu. Estamos trabalhando na correção deste problema.\nMensagem técnica: " + err.message,
                        "Ok"
                    );
                }
            }
        );

    };
    
    
    var _acaoMenu = function() {

        $$("#menuAtualizarLista, #btnAtualizarLista").tap(function() {
            Lungo.Aside.toggle(); //hide("#menuOpcoesPrincipal");
            
            if (RastreadorPacotes.Principal.listaSendoAtualizada) {
                return;
            }
            
            RastreadorPacotes.Principal.listaSendoAtualizada = true;
            RastreadorPacotes.Principal.AtualizarLista(true);
        });

        $$("#menuCadastrarPacote").tap(function() {
            //Lungo.Aside.toggle();//Lungo.Aside.hide("#menuOpcoesPrincipal");
            
            _ocultarPull();
            RastreadorPacotes.DadosPacote.Novo();
            
            Lungo.Router.section("telaCadastrarPacote");
            //Lungo.Router.article("telaCadastrarPacote", "cadastrarPacote");
        });

        $$("#menuLerCodigoBarras").tap(function() {
            _ocultarPull();
            MyMobile.LerCodigoBarras("telaCadastrarPacote");
        });
        
        /*$$("#menuAdicionarPorVoz").tap(function() {
            _ocultarPull();
            RastreadorPacotes.CadatrarPacotePorVoz.Novo();
            
            //Lungo.Aside.toggle();
            
            Lungo.Router.section("telaCadastrarPacotePorVoz");
            //Lungo.Router.article("telaCadastrarPacotePorVoz", "vozCodigoRastreio");
        });*/
        
        $$("#menuEditarLista").tap(function() {
            _ocultarPull();
            RastreadorPacotes.Principal.listaEmEdicao = true;
            RastreadorPacotes.Principal.EditarLista();
        });

        $$("#menuLocalizarPacote").tap(function() {
            _ocultarPull();
            //Lungo.Aside.toggle();//Lungo.Aside.hide("#menuOpcoesPrincipal");
            
            //RastreadorPacotes.LocalizarPacote.LimparFiltro();
            RastreadorPacotes.LocalizarPacote.Abrir();
            //Lungo.Router.article("telaLocalizarPacote", "localizarPacote");
        });

        
        $$("#menuCompartilhar").tap(function() {
            _ocultarPull();
            
            var msg = "Conheça o aplicativo \'Rastreador de Pacotes\'. Você cadastra os seus " +
                "pacotes e é avisado automaticamente a cada nova movimentação. Baixe agora mesmo em: " +
                "https://play.google.com/store/apps/details?id=tmz.rastreador. Conheça também o site deste " +
                "aplicativo: www.rastreadordepacotes.com.br";

            MyMobile.Compartilhar(msg);
        });
        
        $$("#menuOpcoesPrincipal [data=menuEntrarEmContato]").tap(function() {
            _ocultarPull();
            RastreadorPacotes.EntrarEmContato();
        });

        /*$$("#menuPreferencias").tap(function() {
            Lungo.Router.section("telaPreferencias");
        });*/
        
        $$("#menuOpcoesPrincipal [data=menuAvaliarAplicativo]").tap(function() {
            RastreadorPacotes.AvaliarNaPlayStore();
        });
        
        $$("#menuOpcoesPrincipal [data=menuSobreApp]").tap(function() {
            _ocultarPull();
            Lungo.Router.section("telaSobreApp");
        });
        
        $$("#menuSair").tap(function() {
            _ocultarPull();
            
            MyMobile.Confirm(
                "Confirmação", 
                "Tem certeza que deseja sair?",
                "Sim,Cancelar",
                function(index) {
                    if (index == 2) { // 2 == cancelar
                        return;
                    }
                    
                    RastreadorPacotes.ResetarLocalStorage();

                    // fecha a aplicação
                    navigator.app.exitApp();
                }
            );
        });
    };
    
    
    
    /*var _alterarMensagemPull = function() {

        var strDataUltimaAtualizacao = "",
            dataLocalStorage = localStorage.getItem("lastUpdate");
        
        if (dataLocalStorage !== null) {
            strDataUltimaAtualizacao = "<br /><span style='position:relative;margin-left:60px;'>" + tmz.Convert.toDateTime(dataLocalStorage, "y-M-d h:m:s", "d/M/y h:m:s") + "</span>";
        }

        _domMensagemPull.html("aa");
        
    };*/
    
    
    var _cancelarEdicaoLista = function() {
        RastreadorPacotes.Principal.listaEmEdicao = false;
        
        $$("#telaPrincipal .liActionRight").hide();
        _domFooter.addClass("hidden");
        
        // deixa todos os checkbox desmarcados
        $$("#listaPacotes [excluir-pacote]:checked").each(function(item) { 
            this.checked = false;
        });
    };
    
    
    var _criarHtmlLista = function(lista) {

        var PACOTE_NAO_MOVIMENTADO = "Este pacote parece que ainda não foi movimentado",
            configCores = _getConfigCores();
        
        
        for (var i = 0; i < lista.length; i++)
        {
            var obj = lista[i],
                pacoteMovimentado = false,
                possuiPosicao = ((obj.Posicao != null) && (obj.Posicao.length > 0)),
                li = document.createElement("LI"),
                strDescricaoUltimaPosicao = "",
                strDataUltimaPosicao = obj.DataUltimaPosicao,
                strDataUltimaPosicaoFormatado = "",
                strTitle = "",
                diasDesdePostagem = 0,
                strDiasDesdePostagem = "",
                postadoEm = _getPostado(obj.Posicao),
                div1 = document.createElement("div"),
                div2 = document.createElement("div"),
                cb = document.createElement("input"),
                spanCodigoRastreio = document.createElement("span"),
                spanDescricao = document.createElement("span"),
                spanData = document.createElement("span");

            li.className = "liComSombra liPequeno"; // selectable";
            li.setAttribute("data-id", obj.Id);

            
            /** apenas para pacotes NÃO movimentados mas que possuem alguma posição **/
            if ( (!pacoteMovimentado) && (possuiPosicao) )
            {
                var cor = _getColor(obj.AcaoUltimaPosicao, configCores);
                if (cor != "") {
                    cor = cor.replace("#", "");
                    li.children[0].style.cssText += "; border-left:6px solid #" + cor + ";";
                }
            }

            // obtém a primeira informação do pacote
            if (possuiPosicao) {
                strDescricaoUltimaPosicao = _getDescricaoUltimaPosicao(obj);
            } else {
                var cor = _getColor("aindaNaoMovimentado", configCores);

                if (cor != "") {
                    cor = cor.replace("#", "");
                    li.children[0].style.cssText += "; border-left:6px solid #" + cor + ";";
                }
            }
            
            

            // formata a data da última posição do pacote
            if ((strDataUltimaPosicao != "" ) && (strDataUltimaPosicao != "0000-00-00 00:00:00")) {
                strDataUltimaPosicaoFormatado = tmz.Convert.toDateTime(
                    strDataUltimaPosicao, 
                    "y-M-d h:m:s", 
                    "d/M/y h:m"
                );

                // se o pacote já foi postado...
                if (postadoEm != null)
                {
                    // define a data atual como sendo HOJE
                    var dataAtual = new Date();
                    
                    // verifica se o pacote já foi entregue...
                    if (obj.Status.toLowerCase() == "entregue") {
                        // se já foi entregue, obtém a informação do pacote entregue
                        dataAtual = _getEntregue(obj.Posicao);
                        dataAtual = (dataAtual == null) ? new Date() : new Date(dataAtual.Data);
                    }
                    
                    var dataFinal = new Date(postadoEm.Data);
                    
                    diasDesdePostagem = tmz.Date.diasDecorridos(dataFinal, dataAtual);
                    diasDesdePostagem = diasDesdePostagem.qtdDias;
                } 
            } else {
                strDataUltimaPosicao = null;
                strDataUltimaPosicaoFormatado = null;
            }
            
            
            
            if ((obj.Posicao != null) && (obj.Posicao.length > 0) && (postadoEm != null)) {
                if (diasDesdePostagem >= 1) {
                    diasDesdePostagem -= 1;
                }
                
                switch (diasDesdePostagem) {
                    case 0: {
                        strDiasDesdePostagem = "hoje";
                        strTitle = "Postado hoje";
                        break;
                    }

                    case 1: {
                        strDiasDesdePostagem = "ontem";
                        strTitle = "Postado ontem";
                        break;
                    }
                    
                    default: {
                        if (diasDesdePostagem == 1) {
                            strDiasDesdePostagem = "ontem";
                            strTitle = "Postado ontem";
                        } else {
                            strDiasDesdePostagem = diasDesdePostagem + " dias";
                            strTitle = "Postado à " + diasDesdePostagem + " dias";
                        }
                         
                        break;
                    }
                }
            }
            
            
            
            if (strDiasDesdePostagem != "") {
                //strTitle = "";
                var strDias = " dias";

                if ((diasDesdePostagem + 1) == 1) { strDias = " dia"; }
                //else { strTitle = "Postado à " + strDiasDesdePostagem; }
                
                strTitle = (obj.Status.toLowerCase() == "entregue") ? "Entregue em " + (diasDesdePostagem + 1) + strDias : strTitle;
                strDiasDesdePostagem = (obj.Status.toLowerCase() == "entregue") ? (diasDesdePostagem + 1) + strDias : strDiasDesdePostagem;
                strDiasDesdePostagem = "<span class=\"tooltip tooltipLeft diasDesdePostagem\" data-message=\"" +strTitle+ "\">" + strDiasDesdePostagem + "</span>";
            }
            

            if (pacoteMovimentado) {
                li.style.cssText += "; border-right: 6px solid #4E944E;";
            }
            
            
            if (cor != "") {
                li.style.cssText += "; border-right:6px solid #" + cor + ";";
            }
            /**
             * fim: COLUNA
             **/

            spanCodigoRastreio.className = "spanCodigoRastreio";
            spanCodigoRastreio.innerHTML = obj.CodigoRastreio;
            
            spanDescricao.className = "spanDescricao";
            spanDescricao.innerHTML = (obj.Descricao || "");


            
            div1.className = "liAction";
            div1.appendChild(spanCodigoRastreio);
            div1.appendChild(document.createElement("BR"));
            
            div1.appendChild(spanDescricao);
            div1.appendChild(document.createElement("BR"));
            

            if (strDataUltimaPosicaoFormatado != null) {
                spanData.className = "spanData";
                spanData.innerHTML = (strDataUltimaPosicaoFormatado || "<br>") + ("<br>" + strDescricaoUltimaPosicao || PACOTE_NAO_MOVIMENTADO);
            
                div1.appendChild(spanData);
                div1.appendChild(document.createElement("BR"));
            }
            
            
            //cb.type = "checkbox";
            //cb.setAttribute("data-id", obj.id);

            
            // faz a opção de exclusão
            var fieldset = document.createElement("fieldset");
            fieldset.style.cssText = "margin-bottom: 0px;background: transparent; -webkit-border-radius: 26px; -moz-border-radius: 26px; -ms-border-radius: 26px; -o-border-radius: 26px; border-radius: 26px;";

            var inputExcluir = document.createElement("input");
            inputExcluir.type = "checkbox";
            inputExcluir.className = "inline right";
            inputExcluir.setAttribute("excluir-pacote","");
            
            fieldset.appendChild(inputExcluir);
            
            div2.className = "liActionRight";
            div2.appendChild(fieldset);
            
            
            li.appendChild(div1);
            li.appendChild(div2);
            

            _domUL[0].appendChild(li);
        }

        _definirEventosLista();
    };
    

    var _criarLista = function(lista, adicionarEmLocalStorage) {

        _apagarLista(adicionarEmLocalStorage);
        //this.DisableButton();
        
        if ((lista == null) || (lista.length == 0)) {
            //"lblNumeroPacotes".setValue("Sem pacotes");
            _definirEventosLista();
            return;
        }

        if (adicionarEmLocalStorage) {
            RastreadorPacotes.lista = lista;
            localStorage.setItem("list", JSON.stringify(lista));
        }


        var objSearch = JSON.parse(localStorage.getItem("search")),
            lista = _prepararLista(lista),
            retornoFiltro = _filtrarLista(objSearch, lista);
            
            
        _domLblTotalPacotes.html("( " + retornoFiltro.lista.length + " )");
        _domEmptyListaPacotes.hide();
            
        // se NÃO filtrou...
        if (!retornoFiltro.filtrou) {
            _criarHtmlLista(retornoFiltro.lista);
            _domMenuLocalizarPacote.removeClass("active");
            _domEmptyFiltroVazio.hide();
            
            if (lista.length == 0) {
                _domEmptyListaPacotes.show();
            }

            return;
        }
        
        /**********************************************************************
         ** SE CAIU AQUI É PORQUE FILTROU A LISTA
         *********************************************************************/
        _criarHtmlLista(retornoFiltro.lista);

        if (retornoFiltro.lista.length == 0) {
            _domEmptyFiltroVazio.show();
            return;
        }
        
        _domEmptyFiltroVazio.hide();
    };
    
    
    
    /**
     * @descrição: Define o click para os controles
     **/
    var _definirAcaoBotoes = function() {
        _acaoMenu();
        
        
        var domListaPacotes = $$("#listaPacotes"),
            domPrincipal = $$("#telaPrincipal"),
            domListaPacotes = $$("#listaPacotes");


        // quando clicar na lista...
        domListaPacotes.tap(function() {

            var menuAberto = $$("#menuOpcoesPrincipal").hasClass("show");
            RastreadorPacotes.Principal.menuAberto = menuAberto;

            if (menuAberto) {
                // oculta o menu de opções
                RastreadorPacotes.Principal.abrirDetalhes = false;
                Lungo.Aside.toggle();
            }
        });

        // FOOTER
        $$("#btnCancelarEdicaoLista").tap(function() {
            RastreadorPacotes.Principal.CancelarEdicaoLista();
        });
        
        
        $$("#btnExcluirPacotesSelecionados").tap(function() {
            RastreadorPacotes.Principal.ExcluirPacotesSelecionados();
        });
        // FIM DO FOOTER
    };



    var _definirEventosLista = function() {

        // quando clicar em algum item da lista
        _domBody.find(".liAction").tap(function() {
            
            // se o menu estiver aberto...
            if ((RastreadorPacotes.Principal.menuAberto) && (!RastreadorPacotes.Principal.abrirDetalhes)) {
                return;
            }
            
            if (Lungo.Router.history() == "telaDetalhesPacote") {
                return;
            }
            
            // se estiver editando a lista...
            if (RastreadorPacotes.Principal.listaEmEdicao) {
                // seleciona o checkbox
                var el = $$(this.parentElement).find("[excluir-pacote]");
                el[0].checked = !el[0].checked;

                return;
            }

            var id = this.parentElement.getAttribute("data-id"),
                obj = RastreadorPacotes.GetPacotePeloCampo("Id", id);
                
            if (obj == null) {
                //alert("");
                return;
            }
            
            // altera a interface
            RastreadorPacotes.Detalhes.IniciarPacote(obj);
        });

    };
    
    
    
    var _excluirPacotesSelecionados = function() {
        if ((!app.isOnline) && (app.isMobile)) {
            MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
            _ocultarPull();

            return;
        }

        var listaPacotesSelecionados = $$("#listaPacotes [excluir-pacote]:checked");

        if (listaPacotesSelecionados.length == 0) {
            MyMobile.Alert("", "Por favor, selecione os pacotes que deseja excluir.", "Ok");
            return;
        }


        MyMobile.Confirm(
            "Confirmação", 
            "Tem certeza que deseja excluir os pacotes selecionados?",
            "Sim,Cancelar",
            function(index) {

                if (index == 2) { // 2 == cancelar
                    return;
                }

                var dataIdPacote = "";
                
                for (var i = 0, len = listaPacotesSelecionados.length; i < len; i++) {
                    dataIdPacote += listaPacotesSelecionados[i].parentElement.parentElement.parentElement.getAttribute("data-id");
                    
                    if (i < (len - 1)) {
                        dataIdPacote += ",";
                    }
                }
                
                
                
                var data = _strAcessoWebService;
                data.idPacote = dataIdPacote;

                MyMobile.ActivityStart("", "Excluindo os pacotes...");
        
                $$.post(
                    app.config.server.format("PacoteExcluirPeloId"),
                    data,
                    function(retorno) {
                        
                        MyMobile.ActivityStop();
                        
                        if (!retorno.success) {
                            MyMobile.Alert("", retorno.mensagem, "Ok");
                            return;
                        }
                        
                        var msg = (listaPacotesSelecionados.length > 1) 
                            ? "Pacotes excluídos com sucesso."
                            : "Pacote excluído com sucesso.";
                        
                        MyMobile.Alert("", msg, "Ok");
                        RastreadorPacotes.DeletarHtmlItem(dataIdPacote);
                    }
                );
            }
        );
    };
    
    
    /*var _exibirAvisoAtualizacaoPacote = function() {
        if ((RastreadorPacotes.lista == null) || (RastreadorPacotes.lista.length == 0)) {
            _domEmptyListaPacotes.hide();
            //_domListaSendoAtualizacao.show();

            return;
        }
        
        _domAvisoAtualizacao
            .css("visibility", "visible")
            .css("opacity", "1")
            .css("z-index", "100")
            .css("display", "block");
    };


    var _ocultarAvisoAtualizacaoPacote = function() {
        if ((RastreadorPacotes.lista == null) || (RastreadorPacotes.lista.length == 0)) {
            _domEmptyListaPacotes.show();
            //_domListaSendoAtualizacao.hide();

            return;
        }
        
        _domAvisoAtualizacao
            .css("visibility", "hidden")
            .css("opacity", "0")
            .css("z-index", "0");
    };*/
    
    
    var _filtrarLista = function(filter, lista) {

        // verifica se a lista de pacotes é VAZIA
        if ((lista == null) || (lista.length == 0)) {
            return {
                filtrou: false,
                lista: []
            };
        }


        var objSort = JSON.parse(localStorage.getItem("sort"));

        // verifica se informou algo para filtrar
        // se não existir o objeto 'filter' OU se existir, porém todos os atributos forem vazios...
        if ( (filter == null) || ((filter.data == "") && (filter.texto == "") && (filter.palavraChave == "") && (filter.status == ""))) {

            if ((objSort != null) && (lista != null)) {
                lista.sort(tmz.dynamicSort(objSort.by, objSort.order, objSort.type));
            }

            return {
                filtrou: false,
                lista: lista
            };
        }
        

        // existe pacote na lista, vai procurar registro pelos filtros aplicados pelo usuário
        var listaOk = [],
            index = -1,
            achou = false;
        
        for (var i = 0; i < lista.length; i++) {
            /**
             * reinicia o flag que indica se achou algum pacote com o filtro informado
             **/
            achou = false;
            
            if ((filter.texto != null) && (filter.texto != "")) {
                // remove todos os caracteres especiais
                var filterTexto = filter.texto.replaceSpecialChars();
                                        
                index = lista[i].CodigoRastreio.indexOf(filterTexto);
                if (index >= 0) {
                    achou = true;
                }
                
                // remove todos os caracteres especiais
                var descricao = lista[i].Descricao.toLowerCase().replaceSpecialChars();
                
                index = descricao.indexOf(filterTexto);
                if (index >= 0) {
                    achou = true;
                }
                
                // se informou o texto e não achou nada, não faz sentido continuar...
                if (!achou) {
                    continue;
                }
            } else {
                // se não informou o texto, diz então que ACHOU o pacote
                achou = true;
            }
            
            /// verifica se o usuário informou data para filtrar e se o objeto lista possui posição
            if ((filter.data != null) && (filter.data != "") && (filter.data != "dd/mm/aaaa")) {
                
                if ((lista[i].Posicao != null) && (lista[i].Posicao.length >= 1)) {
                    var dataPosicaoStr = tmz.Convert.toDateTime(lista[i].Posicao[lista[i].Posicao.length-1].Data, "y-M-d h:m:s", "y-M-d"),
                        dataPosicao = new Date(dataPosicaoStr.replaceAll("-", "/")),
                        dataUS = new Date(filter.dataUS.replaceAll("-", "/"));
                    
                    switch (filter.tipoComparacaoData) {
                        case "<=": {
                            achou = (dataPosicao.getTime() <= dataUS.getTime());
                            break;
                        }
                        case "==": {
                            achou = (dataPosicao.getTime() == dataUS.getTime());
                            break;
                        }
                        case ">=": {
                            achou = (dataPosicao.getTime() >= dataUS.getTime());
                            break;
                        }
                    }
                }
                
                // se informou a data e não achou nada, não faz sentido continuar...
                if (!achou) {
                    continue;
                }
            }

            if ((filter.palavraChave != null) && (filter.palavraChave != "")) {
                // remove todos os caracteres especiais
                var palavraChave = filter.palavraChave.replaceSpecialChars(),
                    categoria = lista[i].Categoria.replaceSpecialChars();
                
                // verifica se achou...
                if (categoria.toLowerCase().indexOf(palavraChave) >= 0) {
                    achou = true;
                }

                // se informou a data e não achou nada, não faz sentido continuar...
                if (!achou) {
                    continue;
                }
            } else {
                achou = true;
            }
            
            
            if (filter.status != "") {
                // se o status selecionado for igual à TODOS, diz que encontrou o pacote    
                if (filter.status.toLowerCase() == "todos") {
                    achou = true;
                } else if ((filter.status == "naomovimentado") && (lista[i].AcaoUltimaPosicao == "")) {
                    achou = true;
                } else if (filter.status.toLowerCase() == lista[i].AcaoUltimaPosicao.toLowerCase()) {
                    achou = true;
                } else if ((filter.status.toLowerCase() == "ignorarentregue") && (lista[i].Status.toLowerCase() != "entregue")) {
                    achou = true;
                } else {
                    achou = false;
                }
            }
            
            if (achou) {
                listaOk.push( lista[i] );
            }
        }
        
        var filtrou = (listaOk.length != lista.length);//,
            //sort = (objSort.order.toLowerCase() == "asc") ? "desc" : "asc";
            
        if (filtrou) {
            _domMenuLocalizarPacote.addClass("active");
        } else {
            _domMenuLocalizarPacote.removeClass("active");
        }


        // vai ordenar a lista
        listaOk.sort(tmz.dynamicSort(objSort.by, "desc", objSort.type));

        // aplica o filtro, mesmo que não ache nenhum pacote. 
        // se não achar nenhum pacote, irá exibir uma lista vazia mesmo
        //_criarLista(listaOk, false);
        //RastreadorPacotes.Principal.ModifiedButtonFilter(filtrou);
        

        // retorna TRUE se encontrar algum pacote com os filtros informados
        return {
            filtrou: filtrou,
            lista: listaOk
        };
    };


    var _getColor = function(acao, configCores)
    {
        if (acao == null) {
            return "";
        }
        
        acao = acao.replaceAll(" ", "").toLowerCase();
        
        switch (acao) {
            case "entregaefetuada": { acao = "entregue"; break; }
        }

        for (var c in configCores) { 
            if (c == null) { continue; }
            if (configCores[c] == "") { continue; }
            
            if (c.trim().toLowerCase() == acao) {
                return configCores[c];
            }
        }
        
        return "";
    };
    
    
    
    var _getConfigCores = function() {
        var usuario = JSON.parse(localStorage.getItem("user"));
        
        if (usuario.configuracao == null) {
            return null;
        }
        
        if (usuario.configuracao.trim() != "") {
            return JSON.parse(usuario.configuracao).cores;
        }
        
        return null;
    }
    
    
    var _getDescricaoUltimaPosicao = function(objPacote)
    {
        if ((objPacote == null) || (objPacote.Posicao == null) || (objPacote.Posicao.length == 0))
        {
            return "";
        }
        
        var acao1 = objPacote.Posicao[objPacote.Posicao.length-1].Acao.toLowerCase(),
            indice = acao1.indexOf("saiu para entrega");
        
        // verifica se a primeira informação do pacote é...
        if (
            (acao1 != "postado") &&
            (acao1 != ENTREGA_EFETUADA) &&
            (acao1 != "encaminhado") &&
            (acao1 != "postagem - dh") &&
            (acao1 != "objeto postado") &&
            (acao1 != "objeto encaminhado") &&
            (acao1 != "aguardando retirada") &&
            (acao1 != "objeto postado após o horário limite da agência") &&
            (indice < 0)
           )
        {
            return objPacote.Posicao[objPacote.Posicao.length-1].Acao + "<br />" + objPacote.Posicao[objPacote.Posicao.length-1].Detalhes; 
        }
        
        return objPacote.Posicao[objPacote.Posicao.length-1].Detalhes;
    };


    /**
     * obtém a posição de ENTREGUE
     **/
    var _getEntregue = function(oLista) {

        if ((oLista == null) || (oLista.length == 0)) {
            return null;
        }
        
        for (var i = 0; i < oLista.length; i++) {
            if (oLista[i].Acao.toLowerCase() == ENTREGA_EFETUADA) {
                return oLista[i];
            }
        }
        
        return null;    
    };


    /**
     * obtém a posição de POSTADO
     **/
    var _getPostado = function(oLista) {
        
        if ((oLista == null) || (oLista.length == 0)) {
            return null;
        }
        
        for (var i = 0; i < oLista.length; i++) {
            if ((oLista[i].Acao.toLowerCase() == "postado") ||
                (oLista[i].Acao.toLowerCase() == "postagem - dh") ||
                (oLista[i].Acao.toLowerCase() == "objeto postado") ||
                (oLista[i].Acao.toLowerCase() == "objeto postado após o horário limite da agência")
               )
            {
                return oLista[i];
            }
        }
        
        return null;
    };
    
    
    
    var _iniciarPull = function() {
      
        _pullListaPacotes = new Lungo.Element.Pull("article#listaPacotes", {
            onPull: "Puxe para baixo para atualizar",
            onRelease: "Solte para atualizar",
            onRefresh: "Atualizando pacotes...",
            callback: function() {
                if (RastreadorPacotes.Principal.listaSendoAtualizada) {
                    return;
                }
                
                RastreadorPacotes.Principal.listaSendoAtualizada = true;
                RastreadorPacotes.Principal.AtualizarLista(false);
            }
        });
        
        //_domMensagemPull = $$("#telaPrincipal [data-control=pull] strong");
        
    };
    
    
    var _prepararLista = function(lista) {
        if (lista == null) {
            return;
        }
        
        var search = JSON.parse(localStorage.getItem("search"));

        for (var i = 0; i < lista.length; i++)
        {
            var obj = lista[i],
                possuiPosicao = ((obj.Posicao != null) && (obj.Posicao.length > 0));

            /**
             * define atributos que serão utilizados quando fizer o SORT pela coluna
             **/
            lista[i].AcaoUltimaPosicao = (possuiPosicao) ? obj.Posicao[obj.Posicao.length-1].Acao : "";
            lista[i].DataUltimaPosicao = (possuiPosicao) ? obj.Posicao[obj.Posicao.length-1].Data : "";
            lista[i].DescricaoUltimaPosicao = _getDescricaoUltimaPosicao(obj);
        }
        
        return lista;
    };
    
    
    var _ocultarPull = function() {
        RastreadorPacotes.Principal.listaSendoAtualizada = false;
        
        if (_pullListaPacotes == null) {
            return;
        }
        
        _pullListaPacotes.hide();
    };
    
    
    
    return {
        
        abrirDetalhes: true,
        listaEmEdicao: false,
        listaSendoAtualizada: false,
        menuAberto: false,


        // deixar apenas a function para definir acao botões
        Init: function() {
            _strAcessoWebService = RastreadorPacotes.StrAcessoWebService();
            _definirAcaoBotoes();
            _iniciarPull();
        },


        AbrirCadastro: function(codigoRastreio) {
            alert(codigoRastreio);
        },
        

        AtualizarLista: function(exibirMensagem) {
            _atualizarLista(exibirMensagem);
        },

        ApagarLista: function() {
            _apagarLista();
        },
    
        CancelarEdicaoLista: function() {
            _cancelarEdicaoLista();
        },

        CriarLista: function(lista, adicionarEmLocalStorage) 
        {
            _criarLista(lista, adicionarEmLocalStorage);
        },
        
        DadosAcesso: function(str) {
            _strAcessoWebService = str;
        },
        
        EditarLista: function() {
            if ((!app.isOnline) && (app.isMobile)) {
                MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
                _ocultarPull();
    
                return;
            }
            
            if ((RastreadorPacotes.lista == null) || (RastreadorPacotes.lista.length == 0)) {
                MyMobile.Alert("", "Você ainda não possui nenhum pacote cadastrado.", "Ok");
                return;
            }

            RastreadorPacotes.Principal.listaEmEdicao = true;
            
            $$("#telaPrincipal .liActionRight").show();
            _domFooter.removeClass("hidden");

            Lungo.Aside.toggle();
        },
        
        
        ExcluirPacotesSelecionados: function() {
            _excluirPacotesSelecionados();
        },
        
        
        /*FiltrarLista: function(filter, lista) {
            return _filtrarLista(filter, lista);
        },


        GetConfigCores: function() 
        {                
            return _getConfigCores();
        },*/
        
        
        GetNovasPosicoes: function(id, ultimoIndice) {

            //_domMensagemAvisoAtualizacao.text("Atualizando as posições dos pacotes");
            //_exibirAvisoAtualizacaoPacote();
            //MyMobile.Toast("Atualizando os pacotes");
            MyMobile.ActivityStart("", "Atualizando os pacotes...");
            
            var data = _strAcessoWebService;
            data.id = id;
    
            $$.post(
                app.config.server.format("PacoteGetNovasPosicoes"),
                data,
                function(retorno) { 
                    
                    //_ocultarAvisoAtualizacaoPacote();
                    MyMobile.ActivityStop();
                    
                    if (retorno == null) {
                        RastreadorPacotes.Principal.ProcessarGetNovasPosicoes(ultimoIndice);
                        return;
                    }
                    

                    // verifica se houve algum retorno
                    // o retorno pode ser 0 se nenhum dos pacotes da iteração atual tiver sido movimentado
                    if (retorno.totalRegistros == 0) {
                        RastreadorPacotes.Principal.ProcessarGetNovasPosicoes(ultimoIndice+1);
                        return;
                    }
                    
                    
                    var listaAtual = JSON.parse(localStorage.getItem("list")),
                        indice = -1;
                    
                    for (var i = 0; i < retorno.rows.length; i++) 
                    {
                        var posicao = retorno.rows[i].Posicao;
                        if ((posicao == null) || (posicao.length == 0)) {
                            continue;
                        }
                        
                        // procura na listaAtual, um objeto com o atributo CodigoRastreio
                        // obtém o índice na listaAtual
                        indice = listaAtual.searchInObject("CodigoRastreio", retorno.rows[i].CodigoRastreio);
                        
                        if ((indice >= 0) && (listaAtual[indice].CodigoRastreio == retorno.rows[i].CodigoRastreio)) {
                            listaAtual[indice] = retorno.rows[i]; //.reverse();
                        }
                    }
                    
                    // cria a lista
                    RastreadorPacotes.Principal.CriarLista(listaAtual, true);
                    RastreadorPacotes.Principal.ProcessarGetNovasPosicoes(ultimoIndice+1);
                }
            );
        },
        
        
        IniciarPull: function() {
            _iniciarPull();
        },
        
        
        PrepararLista: function(lista) {
            return _prepararLista(lista);
        },
        
        
        ProcessarGetNovasPosicoes: function(ultimoIndice, exibirMensagem) {
            var listaAtual = JSON.parse(localStorage.getItem("list"));
            
            if ((listaAtual == null) || (listaAtual.length == 0)) {
                //fnCallback.call(this, ultimoIndice+1);
                return;
            }
            
            var MAX_PACOTES_AGRUPADOS = 3,
                MAX_MINUTOS = 15,
                dataAtual = new Date(),
                id = "",
                count = 0;
            
            ultimoIndice = ultimoIndice || 0;

            for (var i = ultimoIndice; i < listaAtual.length; i++) {
                if (listaAtual[i].Status.toLowerCase() == "entregue") {
                    continue;
                }
                
                // verifica a diferença da data atual e a data da última atualização
                var dataAtualizacao = new Date(listaAtual[i].DataUltimaAtualizacao),
                    diff = Math.round((dataAtual - dataAtualizacao)/1000) / 60;
                
                if (diff <= MAX_MINUTOS) {
                    continue;
                }
                
                id += listaAtual[i].Id;
                if (i < (listaAtual.length - 1)) {
                    id += ",";
                }
                
                count += 1;
                ultimoIndice = i;

                if (count == MAX_PACOTES_AGRUPADOS) {
                    break;
                }
            }
            
            if (id == "") {
                // retorna false pois já estou ocultando o Pull logo acima
                return; 
            }

            // se o último caractere foi uma VIRGULA...
            if (id.substr(id.length-1, 1) == ",") {
                id = id.substr(0,id.length-1);
            }

            RastreadorPacotes.Principal.GetNovasPosicoes(id, ultimoIndice);
            return;
        }
    };
}();