var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.LocalizarPacote = function() {
    "use strict";
    
    
    var _domData = document.getElementById("txtLocalizarPorData"),
        _domTexto = document.getElementById("txtLocalizarPorTexto"),
        _domPalavraChave = document.getElementById("txtLocalizarPorPalavraChave"),
        _domStatus = document.getElementById("selStatus"),
        _domMenuLocalizarPacote = $$("#menuLocalizarPacote");
    

    var _adicionarStatus = function() {
        var lista = JSON.parse(localStorage.getItem("list"));
        if ((lista == null) || (lista.length == 0)) {
            return;
        }
        
        var status = [];
        for (var i = 0; i < lista.length; i++) {
            status.push( (lista[i].AcaoUltimaPosicao || "") );
        }
        
        status = status.removeDuplicate();
        status.sort();
        
        var l = [];
        l.push({value:"todos", text:"Todos"});
        l.push({value:"ignorarentregue", text: "Ocultar os já entregues"});
        
        for (var i = 0; i < status.length; i++) {
            var v = (status[i] == "") ? "naomovimentado" : status[i],
                s = (status[i] == "") ? "Apenas os não movimentados" : status[i];

            l.push({value:v, text:s});
        }
        
        "selStatus".clear();
        tmz.ComboBox.Add({
            el: "selStatus", 
            itens: l
        })
    };


    var _definirAcaoBotoes = function() {
        $$("article#localizarPacote [data-action=localizar]").tap(function() {
            RastreadorPacotes.LocalizarPacote.Filtrar();
        });


        $$("article#localizarPacote [data-action=limpar]").tap(function() {
            RastreadorPacotes.LocalizarPacote.LimparFiltro();
        });
    };
    
    
    
    return {
        Init: function() {
            _definirAcaoBotoes();
        },
        
        
        Abrir: function() {

            if ((RastreadorPacotes.lista == null) || (RastreadorPacotes.lista.length == 0)) {
                MyMobile.Alert("", "Você ainda não possui nenhum pacote cadastrado.", "Ok");
                return;
            }
            
            RastreadorPacotes.LocalizarPacote.AdicionarStatus();
            
            var objSearch = localStorage.getItem("search");
            if (objSearch != null) {
                objSearch = JSON.parse(objSearch);
                
                _domData.value = tmz.Convert.toDateTime(objSearch.data.replaceAll("/", "-"), "d-m-y", "d/M/y").replaceAll("/", "-");
                _domTexto.value = objSearch.texto;
                _domPalavraChave.value = objSearch.palavraChave;

                tmz.ComboBox.SelecionarIndexPeloValue("selEscolherComparacaoData", objSearch.tipoComparacaoData);
                tmz.ComboBox.SelecionarIndexPeloValue("selStatus", objSearch.status);
            }

            Lungo.Router.section("telaLocalizarPacote");
        },
        
        
        AdicionarStatus: function() {
            _adicionarStatus();
        },
        
        
        Filtrar: function() {
            
            // necessário validar a data
            var domData = document.getElementById("txtLocalizarPorData"),
                dataStr = domData.value,
                re = new RegExp(/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/),
                m = re.exec(dataStr),
                dataStrUS = "";
                
            // se for != null, significa que a data esta em formato YYYY-MM-DD
            if (m != null) {
                dataStrUS = dataStr;
                dataStr = tmz.Convert.toDateTime(dataStr, "y-M-d", "d/M/y");
            } else {
                
            }
            
            
            var search = tmz.StringToObject(tmz.FormToString("frmLocalizar")),
                lista = JSON.parse(localStorage.getItem("list"));
                
            if (search.data != null) {
                search.data = dataStr;
                search.dataUS = dataStrUS;
            }

            localStorage.setItem("search", JSON.stringify(search));
            _domMenuLocalizarPacote.removeClass("active");

            RastreadorPacotes.Principal.CriarLista(lista, false);
            Lungo.Router.back();
        },


        LimparFiltro: function() {
            _domData.value = "";
            _domTexto.value = "";
            _domPalavraChave.value = "";
            
            tmz.ComboBox.SelecionarIndexPeloValue("selEscolherComparacaoData", "<=");
            tmz.ComboBox.SelecionarIndexPeloValue("selStatus", "todos");
            
            _domMenuLocalizarPacote.removeClass("active");
            $$("#emptyFiltroVazio").hide();
        }
    };
    
}();