var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.Login = function() {
    "use strict";
    
    var _definirAcaoBotoes = function() {

        Lungo.Events.init({
            "tap #articleLogin a[data-action=login]": function() {
                RastreadorPacotes.Login.EfetuarLogin();
            },
            
            "tap #btnTelaCadastroUsuario": function() {
                Lungo.Router.section("telaCadastroUsuario");
                //Lungo.Router.article("telaCadastroUsuario", "articleCadastrarUsuario");
            },
        
            "tap #btnTelaGerarNovaSenha": function() {
                _domUsuarioNovaSenha.value = _domUsuario.value;
                
                Lungo.Router.section("telaGerarNovaSenha");
                //Lungo.Router.article("telaGerarNovaSenha", "articleGerarNovaSenha");
            }
        });

    };
    
    
    var _domUsuario = document.getElementById("txtLogin"),
        _domPassword = document.getElementById("txtPassword"),
        _domPassword2 = document.getElementById("txtPassword2"),
        _domUsuarioNovaSenha = document.getElementById("txtEmailRecuperarSenha");
    

    return {

        domUsuario: _domUsuario,
        domPassword: _domPassword,
        
        Init: function() {
            _definirAcaoBotoes();
        },
        
        
        EfetuarLogin: function() {

            try {
                if ((!app.isOnline) && (app.isMobile)) {
                    MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
                    return;
                }
                
                var valUsuario = _domUsuario.value.trim(),
                    valPassword = _domPassword.value.trim();
    
    
                if (valUsuario == "") {
                    MyMobile.Toast("Informe o seu email.");
                    return;
                }
                
                var re = /\S+@\S+\.\S+/;
                if (!re.test(valUsuario)) {
                    MyMobile.Toast("Email em formato inválido.");
                    return;
                }
                
                if (valPassword == "") {
                    MyMobile.Toast("Informe a sua senha.");
                    return;
                }

            
                var data = { 
                    l: tmz.Base64.encode(valUsuario),
                    p: tmz.Base64.encode(valPassword),
                    sistema: app.config.sistema,
                    versao: app.config.versao
                };
                

                MyMobile.ActivityStart("", "Efetuando login...");
                //Lungo.Notification.show();
    
                
                $$.post(
                    app.config.server.format("UsuarioGetLogin"),
                    data,
                    function(retorno) { 
    
                        MyMobile.ActivityStop();
                        //Lungo.Notification.hide();
                        
                        if ((retorno == null) || (!retorno.success)) {
                            
                            MyMobile.Alert("", "Usuário ou senha inválidos.", "Ok");
                            return;
                    	}
    
                    	_domUsuario.value = "";
                        _domPassword.value = "";
                        
                        var dataUser = {
                            id: retorno.id,
                            login: retorno.login,
                            nome: retorno.nome,
                            sobrenome: retorno.sobrenome,
                            publicKey: retorno.publicKey
                        };
    
                        localStorage.setItem("user", JSON.stringify(dataUser));

                        // importante ficar depois do setItem acima
                        MyPushNotification.Registrar();

                        Lungo.Router.section("telaPrincipal");
                        
                        try {
                            // registra o serviço
                            //OPA MyBackgroundService.RegisterForBootStart();
                            //OPA MyBackgroundService.Go();
                        } catch(err) {
                            alert("RegisterForBootStart => Error: " + err);
                        }
                        
                        // carrega a lista
                        RastreadorPacotes.Principal.DadosAcesso(RastreadorPacotes.StrAcessoWebService());
                        RastreadorPacotes.Principal.AtualizarLista();
                    }
                );
            } catch(err) {
                MyMobile.Alert("Erro...", err, "Ok");
            }

        }
    };
    
}();



/******************************************************************************
 * GERAR NOVA SENHA
 *****************************************************************************/
RastreadorPacotes.RecuperarSenha = function() {
    "use strict";
    
    
    var _definirAcaoBotoes = function() {

        Lungo.Events.init({
        	"tap article#articleGerarNovaSenha a[data-action=gerarNovaSenha]": function() {
                RastreadorPacotes.RecuperarSenha.Salvar();
            }
        });
            
    };


    var _domLogin = document.getElementById("txtEmailRecuperarSenha")
    
    return {
        domLogin: _domLogin,
        
        Init: function() {
            _definirAcaoBotoes();
        },
        
        Salvar: function() {
            
            try {
                
                if ((!app.isOnline) && (app.isMobile)) {
                    MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
                    return;
                }
                
                var valLogin = _domLogin.value.trim();
                    
                if (valLogin == "") {
                    MyMobile.Toast("Informe o seu email.");
                    return;
                }
                
                var re = /\S+@\S+\.\S+/;
                if (!re.test(valLogin)) {
                    MyMobile.Toast("Email em formato inválido.");
                    return;
                }
                
                var data = {
                    login: valLogin,
                    sistema: app.config.sistema
                };
                
                
                MyMobile.ActivityStart("", "Gerando uma nova senha...");
                //Lungo.Notification.show();
    
                
                $$.post(
                    app.config.server.format("UsuarioGerarNovaSenha"),
                    data,
                    function(retorno) {
    
                        MyMobile.ActivityStop();
                        //Lungo.Notification.hide();

                        if ((retorno == null) || (!retorno.success)) {
    
                            MyMobile.Alert(
                                "",
                                (retorno == null) ? "Usuário inválido" : retorno.mensagem,
                                "Ok"
                            );
    
                            return;
                    	}
                        
                        // seta o login na interface de LOGIN
                        document.getElementById("txtLogin").value = data.login;
                        
    
                        MyMobile.Alert(
                            "",
                            retorno.mensagem,
                            "Ok",
                            function() { 
                                Lungo.Router.back();
                            }
                        );
                    }
                );
            } catch (err) {
                MyMobile.Alert("Erro...", err, "Ok");
            }

        }
    };
}();


/******************************************************************************
 * CADASTRAR USUARIO
 *****************************************************************************/
RastreadorPacotes.CadastrarUsuario = function() {
    "use strict";
    
    var _definirAcaoBotoes = function() {
        Lungo.Events.init({
        	"tap article#articleCadastrarUsuario a[data-action=cadastrar]": function() {
                RastreadorPacotes.CadastrarUsuario.Salvar();
            }
        });
    };
    

            
    var _domUsuario = document.getElementById("txtEmailCadastro"),
        _domPassword = document.getElementById("txtPasswordCadastro"),
        _domPassword2 = document.getElementById("txtPasswordCadastro2");
        
        
    
    return {
        
        Init: function() {
            _definirAcaoBotoes();
        },

        Salvar: function() {
            
            try {
                
                if ((!app.isOnline) && (app.isMobile)) {
                    MyMobile.Alert("", "Por favor, verifique a sua conexão com a internet e tente novamente.", "Ok");
                    return;
                }
                
                var valUsuario = _domUsuario.value.trim(),
                    valPassword = _domPassword.value.trim(),
                    valPassword2 = _domPassword2.value.trim();
    
            
                if (valUsuario == "") {
                    MyMobile.Toast("Informe o seu email.");
                    return;
                }
                
                var re = /\S+@\S+\.\S+/;
                if (!re.test(valUsuario)) {
                    MyMobile.Toast("Email em formato inválido.");
                    return;
                }
                
                if (valPassword == "") {
                    MyMobile.Toast("Informe a sua senha.");
                    return;
                }

                if (valPassword2 == "") {
                    MyMobile.Toast("Informe a sua senha.");
                    return;
                } 

                if (valPassword != valPassword2) {
                    MyMobile.Toast("As senhas não conferem.");
                    return;
                }
                
                    
                
                var data = { 
                    Email: tmz.Base64.encode(valUsuario),
                    Password: tmz.Base64.encode(valPassword),
                    sistema: app.config.sistema,
                    versao: app.config.versao
                };
                
                
                MyMobile.ActivityStart("", "Cadastrando...");
                //Lungo.Notification.show();


                $$.post(
                    app.config.server.format("UsuarioCadastrar"),
                    data,
                    function(retorno) {
    
                        MyMobile.ActivityStop();
                        //Lungo.Notification.hide();
    
                        if (retorno == null) {
                            //Lungo.Notification.error('Opa...', 'Usuário ou Senha inválidos', 'remove', 0);
                            MyMobile.Alert("", "Usuário inválido.", "Ok");
                            return;
                    	}
    
    
                        // se deu algum erro
                        if (!retorno.success) {
                            //Lungo.Notification.error('Opa...', retorno.mensagem, 'remove', 0);
                            MyMobile.Alert("", retorno.mensagem, "Ok");
                            return;
                        }
                        

                        //OPAMyBackgroundService.Init();
                        
                        
                        MyMobile.Alert(
                            "",
                            retorno.mensagem,
                            "Ok",
                            function() { 
                                // seta os dados na tela de login
                                RastreadorPacotes.Login.domUsuario.value = valUsuario;
                                RastreadorPacotes.Login.domPassword.value = valPassword;
                                
                                // informa que é um novo usuário
                                localStorage.setItem("usuarioNovo", "true");
                                
                                // efetua o login
                                RastreadorPacotes.Login.EfetuarLogin();
                            }
                        );

                    }
                );
            } catch(err) {
                MyMobile.Alert("Erro...", err, "Ok");
            }
        }
    };
}();