var MyMobile = MyMobile = {};

MyMobile = function() {
    "use strict";

    return {
        
        ActivityStart: function(title, msg) {
            if (app.isMobile) {
                navigator.notification.activityStart(title, msg);
            }
        },
        
        
        ActivityStop: function() {
            if (app.isMobile) {
                navigator.notification.activityStop();
            }
        },
        
        
        Alert: function(title, msg, buttons, callback) {
            if (app.isMobile) {
                navigator.notification.alert(
                    msg,
                    callback,
                    title,
                    buttons
                );
                
                return;
            }
            
            if (navigator.notification == null) {
                alert(msg);
            } else {
                navigator.notification.alert(msg);
            }
        },


        Compartilhar: function(msg) {
            
            try {
                window.plugins.socialsharing.share(msg);
            } catch(err) {
                MyMobile.Alert("Erro...", err, "Ok");
            }
        },
        
        
        Confirm: function(title, msg, buttonLabels, confirmCallback) {
            if (app.isMobile) {
                navigator.notification.confirm(msg, confirmCallback, title, buttonLabels);
                return;
            }
            
            if (confirm(msg)) {
                confirmCallback.call(this, 0);
            }
        },


        EmitirNotificacao: function(id, title, msg, json) {
            if (!app.isMobile) {
                /*MyMobile.Alert(
                    "Erro...", 
                    "A notificação não será exibida pois não é mobile. id: " + id + ", titulo: " + title, 
                    "Ok"
                );*/

                return;
            }

            // vai vibrar
            navigator.notification.vibrate(200);
            

            // https://github.com/katzer/cordova-plugin-local-notifications
            //var now = new Date().getTime()
            //window.plugin.notification.local.add({ message: msg });
            window.plugin.notification.local.add({
                id: id,
                title: title,
                message: msg,
                autoCancel: true,
                ongoing: false, // Prevent clearing of notification (Android only)
                json: (json == null) ? null : JSON.stringify(json),
                icon: 'file://img/icon_128x128.png'
                //repeat: "weekly"//, // daily
                //date: new Date(now + 60 * 1000),
                //sound: 'android.resource://' + package_name + '/raw/beep',
                //badge: 0 // aparece ao lado do ícone
            });


            window.plugin.notification.local.cancelAll = function (callback, scope) {
                //alert(callback);
                //alert(scope);
            };
            
            window.plugin.notification.local.onclick = function (id, state, json) {
                
                if (id < 0) {
                    return;
                }

                
                var lista = localStorage.getItem("list"),
                    data = RastreadorPacotes.StrAcessoWebService();
                 
                // não esta logado ou não tem lista
                if ((data == null) || (lista == null)) {
                    return;
                }
                
                alert(tmz.ObjectToString(data));
                
                lista = JSON.parse(lista);
                var objPacote = Lungo.Core.findByProperty(lista, "Id", id);
                
                if (objPacote == null) {
                    MyMobile.Alert("", "Pacote não encontrado.", "Ok");
                    return;
                }

                RastreadorPacotes.Detalhes.IniciarPacote(objPacote);
                Lungo.Router.section("telaDetalhesPacote");
            };

        },
        
        
        ExitApp: function() {
            
            if (appTimeClickExit) {
                timerClickExit2 = new Date().getTime();
                
                if ( (timerClickExit2 - timerClickExit1) > 1000 ) {
                    appTimeClickExit = false;
                }
            }
        
            if (!appTimeClickExit) {
                timerClickExit1 = new Date().getTime();
                timerClickExit2 = 0;
                appTimeClickExit = true;

                MyMobile.Toast("Pressione novamente para fechar.");
                return;
            }
            

            // se a diferença dos TIMERs for de MENOS de 1000 ms, sai...
            if ( (timerClickExit2 - timerClickExit1) < 1000 ) { 
                navigator.app.exitApp();
                return;
            }
            
            
            appTimeClickExit = false;
            timerClickExit1 = 0;
            timerClickExit2 = 0;
        },


        LerCodigoBarras: function(section) {
            
            try {
                
                cordova.plugins.barcodeScanner.scan(
                    function (result) {
                        var cancelado = result.canceled,
                            formato = result.format, 
                            texto = result.text;
    
                        if (texto.trim() == "") {
                            return;
                        }
    
                        // testa se o texto é um códido de rastreio válido
                        // exemplo: AA123456789BB
                        // DUAS LETRAS / NOVE NÚMEROS / DUAS LETRAS
                        texto = texto.replaceAll(" ", "");
                        
                        if (RastreadorPacotes.ValidarCodigoRastreio(texto)) {
                            Lungo.Router.section(section);
                            RastreadorPacotes.DadosPacote.Novo(texto);
                            return;
                        }
                        
                        MyMobile.Alert("Erro...", "Desculpe, o texto selecionado não é um código de rastreio válido.", "Ok");
                    },
                    function (error) {
                        MyMobile.Alert("Erro...", "Falha ao scannear: " + error, "Ok");
                    }
               );
            }
            catch(err) {

                Lungo.Router.section("telaCadastrarPacote");
                //RastreadorPacotes.DadosPacote.Novo("PG123456789BR");
                
                MyMobile.Alert("Erro...", err, "Ok");
            }
            
        },



        /**
         * MyMobile.RecognizeSpeech(1, "Fale...");
         *
         * @param maxMatches => integer, total de resultados
         **/
        RecognizeSpeech: function(maxMatches, promptString, callback) {
            
            try {
                //var promptString = "Fale o código de rastreio"; // optional
                var language = "pt-BR"; // optional
                
                window.plugins.speechrecognizer.startRecognize(
                    function(result) {
                        callback.call(this, result);
                    }, 
                    function(errorMessage) {
                        console.debug("Erro: " + errorMessage);
                    },
                    maxMatches, 
                    promptString, 
                    language
                );
            } 
            catch (err) {
                MyMobile.Alert("Erro...", err, "Ok");
            }
            

            // Show the list of the supported languages
            /*function getSupportedLanguages() {
                window.plugins.speechrecognizer.getSupportedLanguages(function(languages){
                    // display the json array
                    alert(languages);
                }, function(error){
                    alert("Could not retrieve the supported languages : " + error);
                });
            }*/
        },
        
        /**
         * @descrição: Exibe o toast default do aparelho
         * showShortTop(message)
         * showShortCenter(message)
         * showShortBottom(message)
         * showLongTop(message)
         * showLongCenter(message)
         * showLongBottom(message)
         **/
        Toast: function(msg, tipo) {
            if (app.isMobile) {
                
                if (tipo != null) {
                    window.plugins.toast[tipo](msg);
                    return;
                }
                
                window.plugins.toast.showLongBottom(msg);
                return;
            }

            if (navigator.notification == null) {
                alert(msg);
            } else {
                navigator.notification.alert(msg);
            }
        }

    };
}();