var RastreadorPacotes = RastreadorPacotes || {};

RastreadorPacotes.Notificacoes = function() {
    "use strict";
    
    var _domUL = $$("#telaNotificacao article ul"),
        _domFooter = $$("#telaNotificacao footer");
    
    var _criarHtml = function() {
        
        try {
            
            // vai ordenar a lista
            var lista = RastreadorPacotes.listaNotificacoes;
    
            if ( (lista != null) && (lista.length > 0) ) {
                lista = lista.sort(tmz.dynamicSort("data", "desc", "datetime"));
            }
            
            
            _domUL[0].innerHTML = "";
            
            for (var i = 0, len = lista.length; i < len; i++) {
                var li = document.createElement("li"),
                    divImg = document.createElement("div"),
                    divData = document.createElement("div"),
                    divMsg = document.createElement("div"),
                    spanData = document.createElement("span"),
                    spanMsg = document.createElement("span");
                    
                li.className = "liComSombra";
                li.style.cssText = "background-color: rgb(243, 243, 243) !important; min-height: 140px;";
                
                divImg.className = "divComments";
                
                divData.className = "divTituloData";
                spanData.className = "divTituloDataSpan";
                spanData.innerHTML = tmz.Convert.toDateTime(lista[i].data, "y-M-d h:m:s", "d/M/y h:m");
                divData.appendChild(spanData);
                
                spanMsg.innerHTML = lista[i].msg;
                divMsg.style.cssText = "position:relative;top:10px;margin-bottom: 10px;";
                divMsg.appendChild(spanMsg);
                
                li.appendChild(divImg);
                li.appendChild(divData);
                li.appendChild(divMsg);
                
                _domUL[0].appendChild(li);
            }
            
            if (lista.length > 0) {
                _domFooter.show();
            } else {
                _domFooter.hide();
            }
        } catch(err) {
            alert(err);
        }
    };
    
    
    var _definirAcaoBotoes = function() {
        $$("#telaNotificacao #btnLimparNotificacoes").tap(function() {
            RastreadorPacotes.listaNotificacoes = [];
            Lungo.Router.back();

            _domUL[0].innerHTML = "";
            _domFooter.hide();
        });
    };
    
    return {
        
        Init: function() {
            _definirAcaoBotoes();
        },
        
        Exibir: function() {
            _criarHtml();
            Lungo.Router.section("telaNotificacao");
        }
    };
}();