var MyPushNotification = MyPushNotification || {};

(function() {
    "use strict";
    
    MyPushNotification = function() {
    
        return {
            

            // result contains any error description text returned from the plugin call
            Error: function(error) {
                alert('PushNotification => Error: ' + error);
            },


            GravarRegistro: function(idRegistro) {
                
                try {
                    var data = RastreadorPacotes.StrAcessoWebService();
                    if (data == null) {
                        return;
                    }

                    data.idRegistro = idRegistro;
    
                    $$.post(
                        app.config.server.format("UsuarioRegistrarCelular"),
                        data,
                        function(retorno) {
                            //alert("retorno");
                            //alert(tmz.ObjectToString(retorno));
                        }
                    );
                } catch(err) {
                }

            },


            Registrar: function() {

                //alert(ObjectToString(pushNotification));
        
                try {
                    var pushNotification = window.plugins.pushNotification;

                    pushNotification.register(
                        MyPushNotification.Success,
                        MyPushNotification.Error, 
                        {
                            "senderID": "410821039512", // id do projeto (android only)
                            "ecb": "MyPushNotification.OnNotificationGCM" // event callback that gets called when your device receives a notification
                        }
                    );
                } catch(err) {
                    alert("PushNotification => Error Register: " + err);
                }
        
                /*if (device.platform.toLowerCase() == 'android' || device.platform.toLowerCase() == "amazon")
                {
                    pushNotification.register(
                        MyPushNotification.Success,
                        MyPushNotification.Error, 
                        {
                            "senderID":"410821039512",
                            "ecb":"onNotificationGCM"
                        }
                    );
                }
                else
                {
                    pushNotification.register(
                        MyPushNotification.Token,
                        MyPushNotification.Error, 
                        {
                            "badge": "true",
                            "sound": "true",
                            "alert": "true",
                            "ecb": "onNotificationAPN"
                        });
                }*/
            },
            
    
            Success: function(result) {
                //alert('PushNotification => result: ' + result);
            },
            

            // IOS only
            Token: function(result) {
                // Your iOS push server needs to know the token before it can push to this device
                // here is where you might want to send it the token for later use.
                //alert('device token = ' + result);
            },
    
    
            OnNotificationGCM: function(e) {
                //$$("#app-status-ul").append('<li>EVENT -> RECEIVED ' + e.event + '</li>');
                
                /**
                 * e.foregroud => APLICATIVO ESTA ABERTO
                 **/
                //alert(tmz.ObjectToString(e));

                switch (e.event) {
                    case 'registered': {
                        if ( e.regid.length > 0 ) {
                            //$$("#app-status-ul").append('<li>REGISTERED -> REGID:' + e.regid + "</li>");

                            // Your GCM push server needs to know the regID before it can push to this device
                            // here is where you might want to send it the regID for later use.
                            //alert(e.regid);
                            MyPushNotification.GravarRegistro(e.regid);
                        }
            
                        break;
                    }
                    
                    case 'onUnregistered': {
                        break;
                    }
                
                    case 'message': {
                        // if this flag is set, this notification happened while we were in the foreground.
                        // you might want to play a sound to get the user's attention, throw up a dialog, etc.

                        //$$("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');

                        //if the notification contains a soundname, play it.
                        //var mediaBeep = new Media("/assets/www/beep.wav");// + e.soundname);
                        //mediaBeep.play();
                        
                        switch (e.payload.tipo_mensagem) {
                            case "alterar_configuracao": {
                                break;
                            }
                            
                            /*case "pacote_alterado": {
                                alert("pacote_alterado: " + e.payload.idPacote);
                                break;
                            }*/
                            
                            case "pacote_excluido": {
                                
                                try {
                                    RastreadorPacotes.DeletarHtmlItem(e.payload.idPacote);
                                } catch(err) {
                                    alert(err);
                                }
                                
                                break;
                            }
                            
                            /*case "pacote_incluido": {
                                alert("pacote_incluido: " + e.payload.idPacote);
                                break;
                            }*/
                            
                            case "pacote_movimentado": {
                                
                                var objPacoteNotificacao = e.payload.pacote[0],
                                    objPosicoes = e.payload.posicoes;
                                    
                                
                                //alert(e.payload.idPacote + " - " + e.payload.posicoes.length);
                                RastreadorPacotes.AtualizarPacote(e.payload.idPacote, objPacoteNotificacao, objPosicoes);
                                
                                
                                // 1º) pega o pacote e as posições
                                // 2º) atualiza 'RastreadorPacotes.lista'
                                // 3º) cria o HTML 'RastreadorPacotes.CriarHtml(lista, true);

                                // se for TRUE, significa que o usuário esta com o APP aberto
                                if (e.foreground) {
                                    // se entrou, o APP esta aberto
                                    // não faz nada mesmo, pois já atualizou os dados logo acima
                                } else {
                                    RastreadorPacotes.AbrirDetalhesPacote(idPacote);
                                }
                                
                                break;
                            }
                            
                            case "notificacao": {
                                
                                try {
    
                                    // verifica se a notificação recebida já existe
                                    var res = Lungo.Core.findByProperty(RastreadorPacotes.listaNotificacoes, "id", e.payload.id);
    
                                    // se for NULL significa que esta nofiticação ainda não esta na lista
                                    if (res == null) {
                                        // adiciona a mensagem na lista de notificações recebidas
                                        RastreadorPacotes.listaNotificacoes.push({
                                            id: e.payload.id,
                                            data: e.payload.data_msg,
                                            msg: e.message
                                        });
                                    }
                                        
                                    // se for TRUE, significa que o usuário esta com o APP aberto
                                    if (e.foreground) {
                                        MyMobile.Alert(
                                            "", 
                                            "Você recebeu uma nova mensagem.", 
                                            "Ok", 
                                            function() {
                                                RastreadorPacotes.Notificacoes.Exibir();
                                            }
                                        );
                                    } else {
                                        RastreadorPacotes.Notificacoes.Exibir();
                                    }
                                } catch(err) {
                                    alert(err);
                                }

                                break;
                            }
                        }
                        /*else
                        {
                            // otherwise we were launched because the user touched a notification in the notification tray.
                            if ( e.coldstart ) {
                                $$("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
                            } else {
                                $$("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
                            }
                        }
                
                        $$("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
                        
                        //Only works for GCM
                        $("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
                        
                        //Only works on Amazon Fire OS
                        $status.append('<li>MESSAGE -> TIME: ' + e.payload.timeStamp + '</li>');
                        */
    
                        break;
                    }
            
                    case 'error': {
                        //$$("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
                        break;
                    }
                
                    default: {
                        //$$("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
                        break;
                    }
                }
            }
    
        };
        
    }();

}());