var MyBackgroundService = MyBackgroundService || {};

(function () {
    "use strict";

    MyBackgroundService = function () {

        var _myService, _timer = 15 * 60 * 1000; // 900000

        return {
            Init: function () {
                try {
                    var serviceName = 'com.red_folder.phonegap.plugin.backgroundservice.RastreadorService',
                        factory = cordova.require('com.red_folder.phonegap.plugin.backgroundservice.BackgroundService');

                    _myService = factory.create(serviceName);

                    MyBackgroundService.Go();

                } catch (err) {
                    //app.gravarLog("linha 23 = BackgroundService Erro: Init - message: " + err);
                }
            },


            DisplayError: function (/*data*/) {
                //alert("display error");
                //alert(tmz.ObjectToString(data));
            },


            EnableTimer: function (data) {

                try {
                    if (data.TimerEnabled) {
                        //alert("service now running");
                        return;
                    }

                    _myService.enableTimer(
                        _timer, // 900000
                        function (r) {
                            MyBackgroundService.RegisterForUpdates(r);
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );

                } catch (err) {
                    //app.gravarLog("linha 54 = BackgroundService Erro: EnableTimer - message: " + err);
                }
            },


            GetStatus: function () {

                try {
                    _myService.getStatus(
                        function (r) {
                            MyBackgroundService.UpdateHandler(r, "getStatus");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 71 = BackgroundService Erro: GetStatus - message: " + err);
                }
            },


            Go: function () {

                try {
                    _myService.getStatus(
                        function (r) {
                            //alert(tmz.ObjectToString(r));
    
                            //app.gravarLog("linha 83 = BackgroundService Ok: go -> ServiceRunning " + r.ServiceRunning);
                            MyBackgroundService.StartService(r);
    
    
                            if (!r.RegisteredForBootStart) {
                                ///app.gravarLog("linha 88 = BackgroundService Ok: RegisteredForBootStart false");
                                MyBackgroundService.RegisterForBootStart(r);
                            }
                            /* else {
                            app.gravarLog("linha 91 = BackgroundService Ok: RegisteredForBootStart true");
                            }*/

                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 98 = BackgroundService Erro: Go - message: " + err);
                }
            },

            RegisterForUpdates: function (/*data*/) {

                try {
                    /*if (data.RegisteredForUpdates) {
                        return;
                    }*/

                    _myService.registerForUpdates(
                        function (r) {
                            MyBackgroundService.UpdateHandler(r, "registerForUpdates");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 118 = BackgroundService Erro: RegisterForUpdates - message: " + err);
                }
            },


            DeRegisterForUpdates: function () {

                try {
                    _myService.deregisterForUpdates(
                        function (r) {
                            MyBackgroundService.UpdateHandler(r, "DeRegisterForUpdates");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 135 = BackgroundService Erro: DeRegisterForUpdates - message: " + err);
                }
            },


            RegisterForBootStart: function (data) {

                try {
                    if (data.RegisteredForBootStart) {
                        //alert('Service started, timer enabled and service registered for Boot start');
                        return;
                    }

                    _myService.registerForBootStart(
                        function (r) {
                            //app.gravarLog("linha 150 = BackgroundService Ok: RegisterForBootStart");
                            MyBackgroundService.UpdateHandler(r, "RegisterForBootStart");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 158 = BackgroundService Erro: RegisterForBootStart - message: " + err);
                }

            },


            DeRegisterForBootStart: function () {

                try {
                    _myService.deregisterForBootStart(
                        function (r) {
                            MyBackgroundService.UpdateHandler(r, "DeRegisterForBootStart");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 176 = BackgroundService Erro: DeRegisterForBootStart - message: " + err);
                }
            },


            SetConfiguration: function () {

                try {
                    var config = {
                        'param1': 'p1',
                        'param2': 'p2'
                    };

                    _myService.setConfiguration(
                        config, function (/*r*/) {
                            //MyBackgroundService.UpdateHandler(r, "SetConfiguration");
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 199 = BackgroundService Erro: SetConfiguration - message: " + err);
                }
            },


            StartService: function (data) {

                try {

                    // se o serviço já estiver rodando....
                    if (data.ServiceRunning) {
                        //app.gravarLog("linha 210 = BackgroundService Ok: StartService -> ServiceRunning");
                        MyBackgroundService.EnableTimer(data, "StartService");
                        MyBackgroundService.SetConfiguration();

                        return;
                    }

                    _myService.startService(
                        function (r) {
                            //app.gravarLog("linha 219 = BackgroundService Ok: StartService ok");
                            MyBackgroundService.EnableTimer(r, "startService");
                            MyBackgroundService.SetConfiguration();
                        }, function (e) {
                            MyBackgroundService.DisplayError(e);
                        }
                    );
                } catch (err) {
                    //app.gravarLog("linha 230 = BackgroundService Erro: StartService - message: " + err);
                }

            },


            UpdateHandler: function (data, origem) {

                try {

                    //app.gravarLog("BackgroundService Ok: origem " + origem);
                    //console.debug("SHOW");
                    //alert("UPDATE HANDLER");
                    //pega o resultado do JSONObject do método doWork()
                    //data.LatestResult
                    //pega o resultado do JSONObject do método getConfig
                    //data.Configuration

                    /*// só para teste
                    if (data != null) {
                        if (data.ErrorCode > 0) {
                            MyMobile.Alert("Erro...", data.ErrorMessage, "Ok");
                            return;
                        }

                        if (data.LatestResult != null) {
                            if (typeof data.LatestResult.message != "undefined") {
                                msg = data.LatestResult.message.toString();
                            }
                        }
                    }*/

                    /*MyMobile.EmitirNotificacao(
                        Math.floor((Math.random() * 100) + 1), "service teste", ""
                    );*/

                    console.debug("vai startar getLista");
                    rpBackground.getLista();

                } catch (err) {
                    //app.gravarLog("linha 272 = BackgroundService Erro: UpdateHandler - message: " + err);
                }
            }

        };
    }();

}());